<template>
  <q-page style="min-height: 1px">
    <q-page-sticky position="top-right">
      <q-btn glossy color="accent" :label="$t('register.import.label')"
             class="q-ma-lg" @click="importDialogShow = true" />
    </q-page-sticky>

    <div class="row q-ma-md gutter-x-xs">
      <div>
        <q-input v-model="editorPerson.startingNumber" :label="$t('register.startingNumber')"
                 type="number" class="q-mr-md" style="width: 3.5em;"
                 @keyup="keyPressed" />
      </div>
      <div>
        <q-input v-model="editorPerson.firstName" :label="$t('register.firstName')"
                 class="q-mr-md" style="width: 10em;"
                 @keyup="keyPressed" />
      </div>
      <div>
        <q-input v-model="editorPerson.lastName" :label="$t('register.lastName')"
                 class="q-mr-md"
                 @keyup="keyPressed"/>
      </div>
      <div>
        <q-input v-model="editorPerson.year" :label="$t('register.year')"
                 class="q-mr-md" type="number" style="width: 4em;"
                 @keyup="keyPressed" />
      </div>
      <q-field :label="$t('settings.categories.sex')" stack-label :label-width="4" class="q-mr-md">
        <q-btn-toggle v-model="editorPerson.sex" toggle-color="primary" dense
                      :options="[{ label: $t('default.male'), value: 'm' },
                                   { label: $t('default.female'), value: 'f' },]" />
      </q-field>
      <div>
        <q-input v-model="editorPerson.email" :label="$t('register.email')"
                 class="q-mr-md" style="width: 15em;"
                 @keyup="keyPressed"/>
      </div>
      <div>
        <q-input v-model="editorPerson.club" :label="$t('register.club')"
                 class="q-mr-md" style="width: 15em;"
                 @keyup="keyPressed"/>
      </div>
      <div>
        <q-select v-model="editorPerson.manualCategoryId" class="q-mr-md" style="width: 15em;"
                  :options="extraCategories" :label="$t('register.manual_category')"
                  emit-value map-options>
          <template v-slot:append>
            <q-icon class="cursor-pointer" name="fas fa-times" style="font-size: small"
                    v-if="editorPerson.manualCategoryId && editorPerson.categoryId !== ''"
                    @click.stop="editorPerson.manualCategoryId = null" />
          </template>
        </q-select>
      </div>
      <q-field class="q-mr-lg" borderless stack-label style="width: 3.7em;"
               :label="$t('register.resigned')">
        <q-checkbox v-model="editorPerson.resigned" />
      </q-field>
      <q-btn glossy dense color="secondary" icon="far fa-check-circle"
             @click="saveUser()" style="width: 50px"
             :disable="saveInProgress"
      />

      <q-spinner-hourglass color="primary" size="3em" class="q-ml-lg q-mt-md"
                           v-show="saveInProgress" />

    </div>

    <q-table
      class = "sticky-header-table"
      :style = "tableHeight"
      :title = "$t('default.register')"
      :rows = "filteredTableData"
      :columns = "columns"
      :loading = "loading"
      v-model:pagination = "serverPagination"
      row-key = "_id"
      dense
      color = "primary"
      @request = "loadDataFromDb"
    >
      <template v-slot:top>
        <div class="q-table__title">{{ $t('default.register') }}</div>
        <q-space />
        <q-input dense debounce="300" color="primary" v-model="filter">
          <template v-slot:append>
            <q-icon name="fab fa-searchengin" />
          </template>
        </q-input>
      </template>
      <template v-slot:body-cell-resigned="props">
        <q-td :props="props">
          <span v-if="props.row.resigned" class="fas fa-check"></span>
        </q-td>
      </template>
      <template v-slot:body-cell-editBtn="props">
        <q-td :props="props" style="width:40px">
          <q-btn dense color="secondary" icon="far fa-edit" @click="editRow(props)" />
        </q-td>
      </template>
      <template v-slot:body-cell-delBtn="props">
        <q-td :props="props" style="width:40px">
          <q-btn dense color="secondary" icon="far fa-trash-alt" @click="deleteRow(props)" />
        </q-td>
      </template>
    </q-table>

    <q-dialog v-model="importDialogShow" persistent>
      <q-card style="min-width: 600px">
        <q-card-section>
          <div class="text-h6">{{ $t('register.import.label') }}</div>
        </q-card-section>

        <q-card-section>
          <div v-html="$t('register.import.description')"></div>
        </q-card-section>

        <q-card-section style="font-weight: bold">
          <div v-html="$t('register.import.warning')"></div>
        </q-card-section>

        <q-card-section class="row">
          <div class="col-grow">
            <q-input dense v-model="importFilePath" autofocus
                     @keyup.enter="importDialogShow = false" />
            <input type="file" id="exportPath" @change="setImportPath"
                   ref="fileInput" hidden accept=".csv" />
          </div>
          <div class="float-right">
            <q-btn color="primary" icon="fas fa-folder-open"
                   class="q-ml-md" style="width: 50px"
                   @click="selectImportPath" />
          </div>
        </q-card-section>

        <q-card-actions align="right" class="text-primary">
          <q-btn flat :label="$t('register.import.cancel')" v-close-popup />
          <q-btn flat :label="$t('register.import.ok')"
                 v-close-popup @click="importCsv" />
        </q-card-actions>
      </q-card>
    </q-dialog>
  </q-page>
</template>

<script setup lang="js">
import log from '../service/messaging-service';
import ux from '../service/ux-service';
import {computed, onBeforeMount, onMounted, onUnmounted, reactive, ref, toRaw} from 'vue';
import Person from 'src/model/person';
import {useQuasar} from 'quasar';

const ipcMain = window.ipcMain;
const $q = useQuasar();
const $t = log.getI18n();
const loading = ref(false);
const columns = [{
    name: 'startingNumber',
    field: 'startingNumber',
    label: 'Start. č.',
  }, {
    name: 'lastName',
    field: 'lastName',
    label: 'Příjmení',
  }, {
    name: 'firstName',
    field: 'firstName',
    label: 'Jméno',
  }, {
    name: 'year',
    field: 'year',
    label: 'Rok narození',
  }, {
    name: 'sex',
    field: 'sexLabel',
    label: 'Pohlaví',
  }, {
    name: 'email',
    field: 'email',
    label: 'Email',
  }, {
    name: 'club',
    field: 'club',
    label: 'Tým / Město',
  }, {
    name: 'category',
    field: 'categoryName',
    label: 'Kategorie',
  }, {
    name: 'resigned',
    field: 'resigned',
    label: 'Rezignoval',
  }, {
    name: 'editBtn',
  }, {
    name: 'delBtn',
  }];

const tableData = reactive([]);
const serverPagination = reactive({ page: 1, rowsPerPage: 50 });

const editorPerson = reactive(new Person());
const filter = ref('');
const extraCategories = ref([]);
const importFilePath = ref('');
const importDialogShow = ref(false);
const saveInProgress = ref(false);
const fileInput = ref(null);

const tableHeight = ref('height: 500px');
const filteredTableData = computed(() => {
  if (!filter.value) {
    return tableData;
  }

  if (filter.value.match(/^\d+$/)) {
    // if "filter" is number, it would be filtered by starting number
    return tableData.filter((row) => row.startingNumber === filter.value);
  }

  // otherwise row would be filtered by name case insensitive
  return tableData.filter((row) => `${row.lastName} ${row.firstName}`.toLowerCase().includes(filter.value.toLowerCase()));
});
let debounceResizeFunc = null;

function keyPressed(ev) {
  if (ev.key === 'Enter') {
    saveUser();
  }
}

async function loadDataFromDb({ pagination }) {
  Object.assign(serverPagination, pagination);
  loading.value = true;

  const response = await ipcMain.send('person-filter-data', {});
  if (response.status === 'fail') log.error(response.message);
  else {
    tableData.splice(0, tableData.length);
    response.message
      .forEach((row) => {
        const rowEntity = {
          _id: row._id,
          startingNumber: row.startingNumber,
          lastName: row.lastName,
          firstName: row.firstName,
          year: row.year,
          email: row.email,
          club: row.club,
          sex: row.sex,
          resigned: row.resigned,
          categoryId: row.categoryId,
          categoryName: row.categoryName,
          _entity: row,
        };
        if (row.sex === 'm') {
          rowEntity.sexLabel = $t('default.male');
        } else {
          rowEntity.sexLabel = $t('default.female');
        }
        tableData.push(rowEntity);
      });

    // serverPagination.rowsNumber = response.message.total_rows;
    // serverPagination.page = response.message.offset + 1;
    loading.value = false;
  }

  const ctgResponse = await ipcMain.send('category-get-all-extra');
  if (ctgResponse.status === 'fail') log.error(ctgResponse.message);
  else {
    extraCategories.value = ctgResponse.message
      .map((row) => ({ label: row.name, value: row._id }));
  }
}

async function saveUser() {
  if (containsStartingNumber()) {
    $q.dialog({
      title: $t('default.areYouSure'),
      message: $t('register.duplicateStartingNumber', { number: editorPerson.startingNumber }),
      ok: true,
      cancel: true,
    })
    .onOk(async () => {
      await doSaveUser();
    });
  } else {
    await doSaveUser();
  }
}

async function doSaveUser() {
  saveInProgress.value = true;
  const entity = (editorPerson._entity != null ? toRaw(editorPerson._entity) : new Person());
  entity._id = editorPerson._id;
  entity.startingNumber = editorPerson.startingNumber;
  entity.firstName = editorPerson.firstName;
  entity.lastName = editorPerson.lastName;
  entity.year = editorPerson.year;
  entity.sex = editorPerson.sex;
  entity.email = editorPerson.email;
  entity.club = editorPerson.club;
  entity.resigned = editorPerson.resigned;
  entity.manualCategoryId = editorPerson.manualCategoryId;
  entity.categoryId = editorPerson.manualCategoryId;
  delete entity.categoryName;

  const response = await ipcMain.send('person-save', entity);
  // if (!isCurrentPage()) return;
  if (response.status === 'fail') log.error(response.message);
  else {
    await loadDataFromDb({ pagination: { ...serverPagination } });
    Object.assign(editorPerson, new Person());
    log.info($t('register.saveSuccess'));
  }

  saveInProgress.value = false;
}

function editRow(person) {
  editorPerson._id = person.row._id;
  editorPerson.startingNumber = person.row.startingNumber;
  editorPerson.firstName = person.row.firstName;
  editorPerson.lastName = person.row.lastName;
  editorPerson.year = person.row.year;
  editorPerson.sex = person.row.sex;
  editorPerson.email = person.row.email;
  editorPerson.club = person.row.club;
  editorPerson.resigned = person.row.resigned;
  editorPerson.manualCategoryId = person.row._entity.manualCategoryId;
  editorPerson._entity = person.row._entity;
  if (!extraCategories.value.some((extraCtg) => extraCtg.value === person.row._entity.manualCategoryId)) {
    editorPerson.manualCategoryId = null;
  }
}

function deleteRow(person) {
  $q.dialog({
    title: $t('default.areYouSure'),
    message: $t('register.deletePrompt',
      { firstName: person.row.firstName, lastName: person.row.lastName, id: person.row.startingNumber }),
    ok: true,
    cancel: true,
  })
  .onOk(async () => {
    const response = await ipcMain.send('person-delete', person.row._id);
    // if (!isCurrentPage()) return;
    if (response.status === 'fail') log.error(response.message);
    else {
      await loadDataFromDb({ pagination: { ...serverPagination }});
      log.info($t('register.deleteSuccess'));
    }
  });
  Object.assign(editorPerson, person);
}

function selectImportPath() {
  fileInput.value.click();
}

function setImportPath(file) {
  importFilePath.value = file.target.files[0].path;
}

function resizeTable() {
  tableHeight.value = `height:${window.innerHeight - 150}px`;
}

async function importCsv() {
  const response = await ipcMain.send('import-csv', toRaw(importFilePath.value));
  // if (!isCurrentPage()) return;
  if (response.status === 'fail') {
    if (response.message.startsWith('ERR[')) {
      // error in response => show custom error
      const firstSemi = response.message.indexOf(';');
      const rowNumber = response.message.substr(4, firstSemi - 4);
      const colId = response.message.substr(firstSemi + 1, response.message.indexOf(']') - firstSemi - 1);
      const colName = $t(`register.${colId}`);
      const errorMsg = response.message.substr(response.message.indexOf(':') + 1);
      $q.notify({
        message: $t('register.import.error', { row: rowNumber, col: colName, error: errorMsg }),
        color: 'negative',
        timeout: 10000,
        icon: 'fas fa-exclamation-triangle',
      });
    } else {
      log.error(response.message);
    }
  } else {
    await loadDataFromDb({ pagination: { ...serverPagination }});
    log.info($t('register.import.success'));
  }
}

function containsStartingNumber() {
  return tableData
    .some((row) => row.startingNumber === editorPerson.startingNumber);
}

onBeforeMount(() => {
  debounceResizeFunc = ux.debounce(() => resizeTable(), 250);
  window.addEventListener('resize', debounceResizeFunc);
})

onUnmounted(() => {
  window.removeEventListener('resize', debounceResizeFunc);
})

onMounted(() => {
  // once mounted, we need to trigger the initial server data fetch
  loadDataFromDb({ pagination: { ...serverPagination }});
  resizeTable();
})

    // ipcRenderer.on('person-get-all-data-resp', (event, data) => {
    //   // if (!isCurrentPage()) return;
    //
    //   if (data.status === 'fail') log.error(data.message);
    //   else {
    //     Object.assign(tableData, []);
    //     data.message.docs
    //       .forEach((doc) => {
    //         const rowEntity = {
    //           _id: doc._id,
    //           startingNumber: doc.startingNumber,
    //           lastName: doc.lastName,
    //           firstName: doc.firstName,
    //           year: doc.year,
    //           email: doc.email,
    //           club: doc.club,
    //           sex: doc.sex,
    //           resigned: doc.resigned,
    //           categoryId: doc.categoryId,
    //           _entity: doc,
    //         };
    //         if (doc.sex === 'm') {
    //           rowEntity.sexLabel = $t('default.male');
    //         } else {
    //           rowEntity.sexLabel = $t('default.female');
    //         }
    //         tableData.push(rowEntity);
    //       });
    //
    //     serverPagination.rowsNumber = data.message.total_rows;
    //     serverPagination.page = data.message.offset + 1;
    //     loading.value = false;
    //   }
    // });
</script>

<style lang="scss">
  div.sticky-header-table {
    thead {
      tr {
        th {
          position: sticky;
          z-index: 1;
        }
      }
    }
  }
</style>
